/* Welcome to DmxSimple. This library allows you to control DMX stage and
** architectural lighting and visual effects easily from Arduino. DmxSimple
** is compatible with the Tinker.it! DMX shield and all known DIY Arduino
** DMX control circuits.
**
** DmxSimple is available from: http://code.google.com/p/tinkerit/
** Help and support: http://groups.google.com/group/dmxsimple       */

/* To use DmxSimple, you will need the following line. Arduino will
** auto-insert it if you select Sketch > Import Library > DmxSimple. */

/* Modified for use with DMX shield from www.skpang.co.uk Feb 2010 */
/* Tested with  ECO LED PAR56 from Pulse.                          */

/* For rev E, F board DMX pin is 2   */

#include <DmxSimple.h>

#define RED_CHANNEL 2
#define GRN_CHANNEL 3
#define BLU_CHANNEL 4

int DMX_dir = 4;
int LED2 = 8;



void setup() {
  
  pinMode(DMX_dir, OUTPUT);    
  pinMode(LED2, OUTPUT);       
     
  
  digitalWrite(DMX_dir, HIGH);  // Set direction pin of trasnsceiver to Tx.
  
  /* The most common pin for DMX output is pin 3, which DmxSimple
  ** uses by default. If you need to change that, do it here. */
  DmxSimple.usePin(2);

  /* DMX devices typically need to receive a complete set of channels
  ** even if you only need to adjust the first channel. You can
  ** easily change the number of channels sent here. If you don't
  ** do this, DmxSimple will set the maximum channel number to the
  ** highest channel you DmxSimple.write() to. */
//  DmxSimple.maxChannel(4);
}

void loop() {
  int brightness;
  
  digitalWrite(LED2, HIGH);
  
  /* Simple loop to ramp up brightness  RED */
  for (brightness = 0; brightness <= 255; brightness++) {
    
    /* Update DMX channel to new brightness */
    DmxSimple.write(RED_CHANNEL, brightness);
    
    /* Small delay to slow down the ramping */
    delay(5);
  }
  digitalWrite(LED2, LOW);
  for (brightness = 255; brightness >= 0; brightness--) {
    
    /* Update DMX channel to new brightness */
    DmxSimple.write(RED_CHANNEL, brightness);
    
    /* Small delay to slow down the ramping */
    delay(5);
  }
  
  digitalWrite(LED2, HIGH);
  /* Simple loop to ramp up brightness BLUE */
  for (brightness = 0; brightness <= 255; brightness++) {
    
    /* Update DMX channel to new brightness */
    DmxSimple.write(BLU_CHANNEL, brightness);
    
    /* Small delay to slow down the ramping */
    delay(5);
  }
  
  digitalWrite(LED2, LOW);
  for (brightness = 255; brightness >= 0; brightness--) {
    
    /* Update DMX channel to new brightness */
    DmxSimple.write(BLU_CHANNEL, brightness);
    
    /* Small delay to slow down the ramping */
    delay(5);
  }
  
  digitalWrite(LED2, HIGH);  
  /* Simple loop to ramp up brightness GREEN */
  for (brightness = 0; brightness <= 255; brightness++) {
    
    /* Update DMX channel to new brightness */
    DmxSimple.write(GRN_CHANNEL, brightness);
    
    /* Small delay to slow down the ramping */
    delay(5);
  }
  
  digitalWrite(LED2, LOW);
  for (brightness = 255; brightness >= 0; brightness--) {
    
    /* Update DMX channel to new brightness */
    DmxSimple.write(GRN_CHANNEL, brightness);
    
    /* Small delay to slow down the ramping */
    delay(5);
  }
}
